## hatari 1.7.0

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(Hatari C)

SET(APP_NAME "Hatari")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckCCompilerFlag)
include(DistClean)

# Set build type to "Release" if user did not specify any build type yet
# Other possible values: Debug, Release, RelWithDebInfo and MinSizeRel
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_BUILD_TYPE)

# set(CMAKE_VERBOSE_MAKEFILE 1)

# ##########################
# Conditional build features
# ##########################

set(ENABLE_DSP_EMU 1
    CACHE BOOL "Enable DSP 56k emulator for Falcon mode")
set(ENABLE_TRACING 1
    CACHE BOOL "Enable tracing messages for debugging")
set(ENABLE_SMALL_MEM 0
    CACHE BOOL "Enable to use less memory - at the expense of emulation speed")
set(ENABLE_WINUAE_CPU 0
    CACHE BOOL "Enable WinUAE CPU core (experimental!)")

# Run-time checks with GCC "mudflap" etc features:
# - stack protection
# - checking of pointer accesses
#
# Before running CMake, install "mudflap" library development package
# (libmudflap0-4.4-dev in Debian Squeeze and libmudflap-devel in Fedora).
#
# After this you can configure Hatari with Mudflap:
#   cd build; make clean; cmake -D ENABLE_MUDFLAP:BOOL=1 -D ..
# If everything's fine, CMake output should include:
#   Performing Test MUDFLAP_AVAILABLE - Success"
#
# After (re-)building Hatari, run it with something like this:
#   MUDFLAP_OPTIONS="-viol-gdb" src/hatari --sound off --mic off
# (sound&mic are disabled because threading doesn't work well with Mudflap)
#
# For more info:
#   http://gcc.gnu.org/wiki/Mudflap_Pointer_Debugging
#
set(CMAKE_REQUIRED_LIBRARIES "mudflap")
CHECK_C_COMPILER_FLAG("-fmudflapth" MUDFLAP_AVAILABLE)
set(CMAKE_REQUIRED_LIBRARIES "")
if(MUDFLAP_AVAILABLE)
	set(ENABLE_MUDFLAP 0
	    CACHE BOOL "Enable GCC run-time stack/pointer debugging - with huge slowdown")
endif(MUDFLAP_AVAILABLE)

if(APPLE)
	set(ENABLE_OSX_BUNDLE 1
	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
	# set(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Target architectures" FORCE)
	# set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE STRING "10.6 SDK" FORCE)
	# set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target Min 10.5" FORCE)
	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
else()
	set(ENABLE_OSX_BUNDLE 0
	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
endif(APPLE)

# ####################
# Check for libraries:
# ####################

find_package(SDL REQUIRED)
if(NOT SDL_FOUND)
	message(FATAL_ERROR "SDL library not found!")
endif(NOT SDL_FOUND)

find_package(Math)

find_package(Readline)
if(READLINE_FOUND)
	set(CMAKE_REQUIRED_LIBRARIES "readline")
	check_function_exists(rl_filename_completion_function HAVE_RL_COMPLETION_FUNCTION)
	if(HAVE_RL_COMPLETION_FUNCTION)
		set(HAVE_LIBREADLINE 1)
	else()
		unset(READLINE_FOUND)
	endif(HAVE_RL_COMPLETION_FUNCTION)
	set(CMAKE_REQUIRED_LIBRARIES "")
endif(READLINE_FOUND)

find_package(ZLIB REQUIRED)
if(ZLIB_FOUND)
	set(HAVE_LIBZ 1)
	set(HAVE_ZLIB_H 1)
endif(ZLIB_FOUND)

find_package(PNG)
if(PNG_FOUND)
	set(HAVE_LIBPNG 1)
endif(PNG_FOUND)

find_package(X11)
if(X11_FOUND)
	set(HAVE_X11 1)
endif(X11_FOUND)

find_package(PortAudio)
if(PORTAUDIO_FOUND)
	set(HAVE_PORTAUDIO 1)
endif(PORTAUDIO_FOUND)

# ################
# CPP Definitions:
# ################

# Test for large file support:
execute_process(COMMAND getconf LFS_CFLAGS
                OUTPUT_VARIABLE DETECTED_LFS_CFLAGS
                ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(DETECTED_LFS_CFLAGS)
	add_definitions(${DETECTED_LFS_CFLAGS})
	# message(STATUS "Large filesystem flags: ${DETECTED_LFS_CFLAGS}")
endif(DETECTED_LFS_CFLAGS)

# Additional CFLAGS suggested by the SDL library:
execute_process(COMMAND pkg-config --cflags-only-other sdl
                OUTPUT_VARIABLE DETECTED_SDL_CFLAGS
                ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(DETECTED_SDL_CFLAGS)
	add_definitions(${DETECTED_SDL_CFLAGS})
	# message(STATUS "Additional CFLAGS of SDL: ${DETECTED_SDL_CFLAGS}")
endif(DETECTED_SDL_CFLAGS)

# ###########################
# Check for optional headers:
# ###########################

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(SDL/SDL_config.h HAVE_SDL_SDL_CONFIG_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files("sys/socket.h;sys/un.h" HAVE_UNIX_DOMAIN_SOCKETS)

# #############################
# Check for optional functions:
# #############################

check_function_exists(cfmakeraw HAVE_CFMAKERAW)
check_function_exists(setenv HAVE_SETENV)
check_function_exists(select HAVE_SELECT)
check_function_exists(posix_memalign HAVE_POSIX_MEMALIGN)
check_function_exists(memalign HAVE_MEMALIGN)
check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists(nanosleep HAVE_NANOSLEEP)
check_function_exists(alphasort HAVE_ALPHASORT)
check_function_exists(scandir HAVE_SCANDIR)
check_function_exists(statvfs HAVE_STATVFS)

# #############
# Other CFLAGS:
# #############

# GCC pointer debugging, huge run-time slowdown
if(ENABLE_MUDFLAP)
	# SDL mixer threads so have to use threaded mudflap version
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fstack-protector-all -fmudflapth")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fmudflapth -lmudflap")
endif(ENABLE_MUDFLAP)

# Warning flags:
if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-qual -Wbad-function-cast -Wpointer-arith")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes -Wstrict-prototypes")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wwrite-strings -Wsign-compare")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Wno-unused-parameter -Wno-empty-body")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-security")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -D_FORTIFY_SOURCE=2 -Werror")
endif(CMAKE_COMPILER_IS_GNUCC)

# Building Hatari w/o optimization is no fun...
IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
	set(CMAKE_C_FLAGS "-O ${CMAKE_C_FLAGS}")
ENDIF (CMAKE_BUILD_TYPE STREQUAL "Debug")

# ####################
# Paths configuration:
# ####################

if(NOT BINDIR)
	set(BINDIR bin)
endif()

if(NOT DATADIR)
	set(DATADIR share/hatari)
endif()

if(NOT BIN2DATADIR)
	if(WIN32)
		set(BIN2DATADIR "."
		    CACHE STRING "Relative path from bindir to datadir")
	elseif(ENABLE_OSX_BUNDLE)
		set(BIN2DATADIR "../Resources"
		    CACHE STRING "Relative path from bindir to datadir")
	else()
		set(BIN2DATADIR "../share/hatari"
		    CACHE STRING "Relative path from bindir to datadir")
	endif(WIN32)
	mark_as_advanced(BIN2DATADIR)
endif()

if(NOT MANDIR)
	set(MANDIR share/man/man1)
endif()

if(NOT DOCDIR)
	set(DOCDIR share/doc/hatari)
endif()

if(NOT ETCDIR)
	if(WIN32)
		set(ETCDIR .)
	else()
		set(ETCDIR /etc)
	endif()
endif()
add_definitions(-DCONFDIR=\"${ETCDIR}\")

# #########################################
# Create config.h and recurse into subdirs:
# #########################################

configure_file(${CMAKE_SOURCE_DIR}/cmake/config-cmake.h
		${CMAKE_BINARY_DIR}/config.h)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(tools)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(python-ui)
endif(PYTHONINTERP_FOUND)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/Uninstall.cmake)

=== doc/CMakeLists.txt ===

INSTALL(FILES authors.txt emutos.txt keymap-sample.txt memory-usage.txt
	midi-linux.txt release-notes.txt todo.txt
	DESTINATION ${DOCDIR})

INSTALL(FILES compatibility.html  manual.html
	DESTINATION ${DOCDIR})

INSTALL(DIRECTORY images
	DESTINATION ${DOCDIR})

# if(UNIX)
	add_custom_target(manpages ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatari.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz
		DEPENDS hatari.1)
	INSTALL(FILES  ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== src/CMakeLists.txt ===

set(SOURCES
	acia.c audio.c avi_record.c bios.c blitter.c cart.c cfgopts.c
	clocks_timings.c configuration.c options.c change.c
	control.c cycInt.c cycles.c dialog.c dmaSnd.c fdc.c file.c
	floppy.c gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c ioMem.c
	ioMemTabST.c ioMemTabSTE.c ioMemTabTT.c ioMemTabFalcon.c joy.c
	keymap.c m68000.c main.c midi.c memorySnapShot.c mfp.c
	paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
	scandir.c stMemory.c screen.c screenSnapShot.c shortcut.c sound.c
	spec512.c statusbar.c str.c tos.c unzip.c utils.c vdi.c
	video.c wavFormat.c xbios.c ymFormat.c)

# Disk image code is shared with the hmsa tool, so we put it into a library:
add_library(Floppy createBlankImage.c dim.c msa.c st.c zip.c)

# When building for OSX, define specific sources for gui and ressources
if(ENABLE_OSX_BUNDLE)
	set(GUIOSX_SOURCES
	    gui-osx/AlertHooks.m gui-osx/PrefsController.m gui-osx/Shared.m
	    gui-osx/CreateFloppyController.m gui-osx/SDLMain.m)
	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
	set(GUIOSX_RSRCS
	    gui-osx/Hatari.icns gui-osx/English.lproj gui-osx/French.lproj)
endif(ENABLE_OSX_BUNDLE)

# When building for Windows, define specific sources for gui and resources
# and set the subsystem of the resulting .exe to "windows GUI" instead of "console"
if(WIN32)
	set(GUIWIN_SOURCES gui-win/opencon.c)
	set(GUIWIN_RES gui-win/hatari-winicon.rc)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mwindows")
endif(WIN32)

if(ENABLE_WINUAE_CPU)
	set(CPUDIR cpu)
else()
	set(CPUDIR uae-cpu)
endif(ENABLE_WINUAE_CPU)

include_directories(${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR}
		    includes debug falcon)

if(ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIR})
endif(ZLIB_FOUND)

if(PNG_FOUND)
	include_directories(${PNG_INCLUDE_DIR})
endif(PNG_FOUND)

if(X11_FOUND)
	include_directories(${X11_INCLUDE_DIR})
endif(X11_FOUND)


link_directories(${CMAKE_CURRENT_BINARY_DIR}/debug
		 ${CMAKE_CURRENT_BINARY_DIR}/falcon
		 ${CMAKE_CURRENT_BINARY_DIR}/gui-sdl
		 ${CMAKE_CURRENT_BINARY_DIR}/${CPUDIR})

add_subdirectory(debug)
add_subdirectory(falcon)
add_subdirectory(gui-sdl)
add_subdirectory(${CPUDIR})

# When building for OSX, add specific sources
if(ENABLE_OSX_BUNDLE)
	add_executable(hatari MACOSX_BUNDLE ${GUIOSX_RSRCS} ${SOURCES} ${GUIOSX_SOURCES})
	set_target_properties(hatari PROPERTIES MACOSX_BUNDLE_INFO_PLIST
			      ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/Info-Hatari.plist)
	set(MACOSX_BUNDLE_ICON_FILE Hatari.icns)
	# Create Hatari.app bundle
	add_custom_target(osx_bundle_dirs
			COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources
			COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/MacOS
			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
				   ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources/${MACOSX_BUNDLE_ICON_FILE}
			# Copy Localized .nib to Bundle
			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources/
	)	
	add_dependencies(hatari osx_bundle_dirs)
	set_source_files_properties(${GUIOSX_RSRCS}
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

# When building for Windows, add specific sources + method to compile .rc files
elseif(WIN32)
	# Set a default rc compiler if it was not defined yet
	if(NOT CMAKE_RC_COMPILER)
		set(CMAKE_RC_COMPILER windres)
	endif(NOT CMAKE_RC_COMPILER)
	ENABLE_LANGUAGE(RC)
	set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -Ocoff -o <OBJECT> <SOURCE>")
	set_source_files_properties(${GUIWIN_RES} PROPERTIES LANGUAGE RC)
	add_executable(hatari ${GUIWIN_RES} ${SOURCES} ${GUIWIN_SOURCES})

# Other targets, use default sources
else()
	add_executable(hatari ${SOURCES})
endif(ENABLE_OSX_BUNDLE)

target_link_libraries(hatari Falcon GuiSdl Floppy UaeCpu Debug ${SDL_LIBRARY})

if(MATH_FOUND AND NOT APPLE)
	target_link_libraries(hatari ${MATH_LIBRARY})
endif()

if(SDLMAIN_LIBRARY)
	target_link_libraries(hatari ${SDLMAIN_LIBRARY})
endif(SDLMAIN_LIBRARY)

if(READLINE_FOUND)
	target_link_libraries(hatari ${READLINE_LIBRARY})
endif(READLINE_FOUND)

if(ZLIB_FOUND)
	target_link_libraries(hatari ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

if(PNG_FOUND)
	target_link_libraries(hatari ${PNG_LIBRARY})
endif(PNG_FOUND)

if(X11_FOUND)
	target_link_libraries(hatari ${X11_LIBRARIES})
endif(X11_FOUND)

if(PORTAUDIO_FOUND)
	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
endif(PORTAUDIO_FOUND)

if(WIN32)
	# Needed for socket() on Windows
	target_link_libraries(hatari ws2_32)
endif(WIN32)


if(ENABLE_OSX_BUNDLE)
	install(TARGETS hatari BUNDLE DESTINATION /Applications)
else()
	install(TARGETS hatari RUNTIME DESTINATION ${BINDIR})
	install(FILES hatari-icon.bmp DESTINATION ${DATADIR})
	file(GLOB TOS_IMG_FILE tos.img)
	if(TOS_IMG_FILE)
		install(FILES tos.img DESTINATION ${DATADIR})
	endif(TOS_IMG_FILE)
endif(ENABLE_OSX_BUNDLE)

=== src/cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR}) 

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
		           -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT cpustbl.c cpuemu_0.c cpuemu_11.c cpuemu_12.c
				cpuemu_20.c cpuemu_21.c cpuemu_31.c cpuemu_32.c
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c)

	get_target_property(BUILD68K_EXE build68k LOCATION)
	add_custom_command(OUTPUT cpudefs.c
		COMMAND ${BUILD68K_EXE} < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	get_target_property(GENCPU_EXE gencpu LOCATION)
	add_custom_command(OUTPUT cpustbl.c cpuemu_0.c cpuemu_11.c cpuemu_12.c
				cpuemu_20.c cpuemu_21.c cpuemu_31.c cpuemu_32.c
		COMMAND ${GENCPU_EXE}  DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)


# Generated cpuemu.c contains a lot of warnings we don't really care about...
if(CMAKE_COMPILER_IS_GNUCC)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare -Wno-shadow")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-label")
endif(CMAKE_COMPILER_IS_GNUCC)

add_library(UaeCpu
	cpuemu_0.c cpuemu_11.c cpuemu_12.c cpuemu_20.c cpuemu_21.c cpuemu_31.c
	cpuemu_32.c cpudefs.c cpummu.c cpummu030.c cpustbl.c custom.c
	hatari-glue.c memory.c newcpu.c readcpu.c fpp.c
	)

=== src/uae-cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR}) 

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
		           -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT cpuemu.c cpustbl.c
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c)

	get_target_property(BUILD68K_EXE build68k LOCATION)
	add_custom_command(OUTPUT cpudefs.c
		COMMAND ${BUILD68K_EXE} < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	get_target_property(GENCPU_EXE gencpu LOCATION)
	add_custom_command(OUTPUT cpuemu.c cpustbl.c
		COMMAND ${GENCPU_EXE}  DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)


# Generated cpuemu.c contains a lot of warnings we don't really care about...
if(CMAKE_COMPILER_IS_GNUCC)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare -Wno-shadow")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-label")
endif(CMAKE_COMPILER_IS_GNUCC)

add_library(UaeCpu
	cpudefs.c cpuemu.c cpustbl.c
	hatari-glue.c memory.c newcpu.c readcpu.c fpp.c
	)

=== tests/tosboot/Makefile ===
# Makefile to build the Atari test program and other required files
# for the TOS tester and to run it with minimal or fairly full
# set of options.

# default target is 'test', everything else gets build as its deps
all: test

# targets without corresponding file
.PHONY: clean test test-all


# tos/ subdir should be either symlink to where you have your TOS
# images, or real directory with symlinks to TOS images you want
# to test with this. Or TOSDIR variable needs to point where they are:
#   TOSDIR=/path/to/toses/ make

TOSDIR ?= tos

# TOSDIR should contain at least this!
BUILD_TOS = $(TOSDIR)/etos512k.img

# Hatari machine config for AHCC build
BUILD_CONFIG = -m --machine tt --tos $(BUILD_TOS)

# where the code & test programs are
DIR = disk

# AHCC related files expected for building by disk/ahcc-* hconsole scripts
AHCC_FILES = $(DIR)/ahcc_p.ttp $(DIR)/include $(DIR)/lib


GEMDOS_TEST   = $(DIR)/GEMDOS.PRG
GEMDOS_SCRIPT = $(DIR)/ahcc-gemdos
GEMDOS_DEP    = $(DIR)/gemdos.c $(DIR)/common.c $(DIR)/gemdos.prj $(AHCC_FILES) $(BUILD_TOS)

# build the full GEMDOS emu tester.
# requires:
# - EmuTOS, AHCC and installed Hatari
# before running make:
# - symlink etos512k.img and ahcc_p.ttp + its include & lib dirs
#   under $(DIR)/ subdir
$(GEMDOS_TEST): $(GEMDOS_DEP)
	$(RM) $(DIR)/*.O $(DIR)/*.MAP $(DIR)/*.tmp
	../../tools/hconsole/hconsole.py $(GEMDOS_SCRIPT) -- $(BUILD_CONFIG) $(DIR)
	[ -f $(DIR)/GEMDOS.O ] && [ \! -f $(DIR)/ldfile.tmp ] # verify compiling & linking succeeded


MINIMAL_TEST   = $(DIR)/MINIMAL.PRG
MINIMAL_SCRIPT = $(DIR)/ahcc-minimal
MINIMAL_DEP    = $(DIR)/minimal.c $(DIR)/common.c $(DIR)/minimal.prj $(AHCC_FILES) $(BUILD_TOS)

# build the minimal tester
$(MINIMAL_TEST): $(MINIMAL_DEP)
	$(RM) $(DIR)/*.O $(DIR)/*.MAP $(DIR)/*.tmp
	../../tools/hconsole/hconsole.py $(MINIMAL_SCRIPT) -- $(BUILD_CONFIG) $(DIR)
	[ -f $(DIR)/MINIMAL.O ] && [ \! -f $(DIR)/ldfile.tmp ] # verify compiling & linking succeeded


clean:
	$(RM) $(DIR)/*.O $(DIR)/*.MAP $(DIR)/*.tmp


# create blank DD floppy image
blank-a.st.gz:
	dd if=/dev/zero of=blank-a.st bs=1024 count=720
	mformat -a -t 80 -h 2 -n 9 -i blank-a.st ::
	gzip blank-a.st


# create 360KB (single side) test floppy that autoruns test program using *.INF file.
# requires:
# - mformat & mcopy from mtools
bootdesk.st.gz: $(MINIMAL_TEST) $(DIR)/TEXT floppy/*.INF
	dd if=/dev/zero of=bootdesk.st bs=1024 count=360
	mformat -a -t 80 -h 1 -n 9 -i bootdesk.st ::
	MTOOLS_NO_VFAT=1 mcopy -i bootdesk.st -spmv $+ ::
	$(RM) $@
	gzip bootdesk.st

# create 360KB (single side) test floppy that autoruns test program from auto/
# as very old TOS versions don't like the *.INF file autorun feature.
# requires:
# - mformat, mcopy & mmd from mtools
bootauto.st.gz: $(MINIMAL_TEST) $(DIR)/TEXT
	dd if=/dev/zero of=bootauto.st bs=1024 count=360
	mformat -a -t 80 -h 1 -n 9 -i bootauto.st ::
	MTOOLS_NO_VFAT=1 mmd -i bootauto.st ::AUTO
	MTOOLS_NO_VFAT=1 mcopy -i bootauto.st -pmv $(DIR)/TEXT ::
	MTOOLS_NO_VFAT=1 mcopy -i bootauto.st -pmv $(MINIMAL_TEST) ::AUTO
	$(RM) $@
	gzip bootauto.st


# optional 16MB HD image for EmuTOS/ACSI testing without HD drivers
# converts floppy desktop infos for HD (A: -> C:)
hd.img: $(MINIMAL_TEST) $(DIR)/TEXT floppy/*.INF
	mkdir tmp
	cp -a $(MINIMAL_TEST) $(DIR)/TEXT tmp/
	for i in floppy/*.INF; do sed -e 's/A:/C:/g' < $$i > tmp/$${i##*/}; done
	../../tools/atari-hd-image.sh 16 $@ LABEL tmp
	$(RM) -r tmp


# requires:
# - Building of floppies & GEMDOS_TEST to have succeeded
# - Latest Hatari to be installed, or to run this with something like:
#   PATH=../../build/src:$PATH make
test: blank-a.st.gz bootauto.st.gz bootdesk.st.gz $(GEMDOS_TEST)
	./tos_tester.py --disks floppy,gemdos --graphics mono --memsizes 4 --machines ste $(BUILD_TOS)

# run all default tests
test-full: blank-a.st.gz bootauto.st.gz bootdesk.st.gz
	./tos_tester.py $(TOSDIR)/*.img

=== debian/changelog ===
hatari (1.7.0-1) unstable; urgency=low

  * New upstream version.
    Highlights:
    - Improvements in the debugger and profiler.
    - Full 6850 ACIA implementation, resulting in better IKBD (keyboard)
      emulation.
  * Refresh patches 01-fix-conftypes-py-build-path and
    02-fix-manpage-hyphens.
  * Add 03-fix-py-extension to drop .py from an installed script.
  * Bump standards-version to 3.9.4, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 14 Jul 2013 15:52:40 +0100

=== debian/control ===
Source: hatari
Section: otherosfs
Priority: optional
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends: debhelper (>= 9),
               libsdl1.2-dev (>=1.2.6-2),
               zlib1g-dev,
               libpng-dev,
               cmake,
               libreadline-dev,
               portaudio19-dev,
               python
Standards-Version: 3.9.4
Homepage: http://hatari.tuxfamily.org/

Package: hatari
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Recommends: binfmt-support
Suggests: mtools, unzip, dosfstools
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 Unlike many other Atari ST emulators which try to give you a good environment
 for running GEM applications, Hatari tries to emulate the hardware of a ST as
 close as possible so that it is able to run most of the old ST games and
 demos.

=== debian/watch ===
version=3
        http://download.tuxfamily.org/hatari/(\d\.\d\.\d)/hatari-(.*).tar.bz2

## hatari 1.8.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,10 @@
 
 cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
+
+if(POLICY CMP0026)
+	# Should be removed if cmake_minimum_required >= 2.8.8
+	cmake_policy(SET CMP0026 OLD)
+endif(POLICY CMP0026)
 
 project(Hatari C)
 
@@ -86,17 +91,10 @@
 
 find_package(Readline)
 if(READLINE_FOUND)
-	set(CMAKE_REQUIRED_LIBRARIES "readline")
-	check_function_exists(rl_filename_completion_function HAVE_RL_COMPLETION_FUNCTION)
-	if(HAVE_RL_COMPLETION_FUNCTION)
-		set(HAVE_LIBREADLINE 1)
-	else()
-		unset(READLINE_FOUND)
-	endif(HAVE_RL_COMPLETION_FUNCTION)
-	set(CMAKE_REQUIRED_LIBRARIES "")
+	set(HAVE_LIBREADLINE 1)
 endif(READLINE_FOUND)
 
-find_package(ZLIB REQUIRED)
+find_package(ZLIB)
 if(ZLIB_FOUND)
 	set(HAVE_LIBZ 1)
 	set(HAVE_ZLIB_H 1)
@@ -107,15 +105,22 @@
 	set(HAVE_LIBPNG 1)
 endif(PNG_FOUND)
 
-find_package(X11)
-if(X11_FOUND)
-	set(HAVE_X11 1)
-endif(X11_FOUND)
+if (NOT ENABLE_OSX_BUNDLE)
+	find_package(X11)
+	if(X11_FOUND)
+		set(HAVE_X11 1)
+	endif(X11_FOUND)
+endif()
 
 find_package(PortAudio)
 if(PORTAUDIO_FOUND)
 	set(HAVE_PORTAUDIO 1)
 endif(PORTAUDIO_FOUND)
+
+find_package(CapsImage)
+if(CAPSIMAGE_FOUND)
+	set(HAVE_CAPSIMAGE 1)
+endif(CAPSIMAGE_FOUND)
 
 # ################
 # CPP Definitions:
@@ -164,6 +169,8 @@
 check_function_exists(alphasort HAVE_ALPHASORT)
 check_function_exists(scandir HAVE_SCANDIR)
 check_function_exists(statvfs HAVE_STATVFS)
+check_function_exists(fseeko HAVE_FSEEKO)
+check_function_exists(ftello HAVE_FTELLO)
 
 # #############
 # Other CFLAGS:
@@ -232,7 +239,14 @@
 		set(ETCDIR /etc)
 	endif()
 endif()
-add_definitions(-DCONFDIR=\"${ETCDIR}\")
+
+if(ENABLE_OSX_BUNDLE)
+	# Use OSX native alert windows and put the config files in the app's bundle
+	add_definitions(-DALERT_HOOKS=1)
+	add_definitions(-DCONFDIR=\"../Resources\")
+else()
+	add_definitions(-DCONFDIR=\"${ETCDIR}\")
+endif()
 
 # #########################################
 # Create config.h and recurse into subdirs:
@@ -252,3 +266,47 @@
 
 add_custom_target(uninstall
     COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/Uninstall.cmake)
+
+
+# ###################################################################
+# Print a summary of the optional libraries with a short explanation:
+# ###################################################################
+
+message( "
+Optional libraries summary :
+----------------------------
+")
+
+if(READLINE_FOUND)
+  message( "  - readline : found, enable history/completion in the debugger" )
+else()
+  message( "  - readline : not found, install it if you wish to enable history/completion in the debugger" )
+endif(READLINE_FOUND)
+
+if(ZLIB_FOUND)
+  message( "  - zlib : found, allow to use zip/gz files directly" )
+else()
+  message( "  - zlib : not found, install it if you wish to use zip/gz files" )
+endif(ZLIB_FOUND)
+
+if(PNG_FOUND)
+  message( "  - png : found, allow to compress screenshot/avi files using png" )
+else()
+  message( "  - png : not found, install it if you wish to compress screenshot/avi files using png" )
+endif(PNG_FOUND)
+
+if(PORTAUDIO_FOUND)
+  message( "  - portaudio : found, enable the microphone input in Falcon mode" )
+else()
+  message( "  - portaudio : not found, install it if you wish to enable the microphone input in Falcon mode" )
+endif(PORTAUDIO_FOUND)
+
+if(CAPSIMAGE_FOUND)
+  message( "  - libcapsimage : v${CAPSIMAGE_VERSION} found, allow to use .IPF, .RAW and .CTR disk images" )
+else()
+  message( "  - libcapsimage : v${CAPSIMAGE_VERSION} not found, install it if you wish to use .IPF, .RAW and .CTR disk images" )
+endif(CAPSIMAGE_FOUND)
+
+message( "" )
+
+

=== python-ui/CMakeLists.txt ===
# conftypes.py is created to source directory (instead of build directory)
# so that Hatari UI can be tested directly from the source directory
add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py
	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/gentypes.py < ${CMAKE_CURRENT_SOURCE_DIR}/../src/configuration.c > ${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../src/configuration.c ${CMAKE_CURRENT_SOURCE_DIR}/gentypes.py)
add_custom_target(conftypes ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py)

INSTALL(PROGRAMS hatariui
	DESTINATION ${BINDIR})

INSTALL(PROGRAMS hatariui.py debugui.py
	DESTINATION ${DATADIR}/hatariui/)

INSTALL(FILES README TODO release-notes.txt hatari-icon.png hatari.png
	config.py dialogs.py hatari.py uihelpers.py
	${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py
	DESTINATION ${DATADIR}/hatariui/)

INSTALL(FILES hatari-icon.png
	DESTINATION share/icons/hicolor/32x32/apps)

INSTALL(FILES hatariui.desktop
	DESTINATION share/applications)

# if(UNIX)
	add_custom_target(hatariui_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatariui.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz
		DEPENDS hatariui.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 	acia.c audio.c avi_record.c bios.c blitter.c cart.c cfgopts.c
 	clocks_timings.c configuration.c options.c change.c
 	control.c cycInt.c cycles.c dialog.c dmaSnd.c fdc.c file.c
-	floppy.c gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c ioMem.c
+	floppy.c floppy_ipf.c floppy_stx gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c ioMem.c
 	ioMemTabST.c ioMemTabSTE.c ioMemTabTT.c ioMemTabFalcon.c joy.c
 	keymap.c m68000.c main.c midi.c memorySnapShot.c mfp.c
 	paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
@@ -22,6 +22,9 @@
 	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
 	set(GUIOSX_RSRCS
 	    gui-osx/Hatari.icns gui-osx/English.lproj gui-osx/French.lproj)
+	set(GUIOSX_DOCS
+	    ${CMAKE_SOURCE_DIR}/doc/manual.html ${CMAKE_SOURCE_DIR}/doc/images
+	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html)
 endif(ENABLE_OSX_BUNDLE)
 
 # When building for Windows, define specific sources for gui and resources
@@ -66,22 +69,33 @@
 
 # When building for OSX, add specific sources
 if(ENABLE_OSX_BUNDLE)
-	add_executable(hatari MACOSX_BUNDLE ${GUIOSX_RSRCS} ${SOURCES} ${GUIOSX_SOURCES})
+	add_executable(hatari MACOSX_BUNDLE ${GUIOSX_RSRCS} ${GUIOSX_DOCS} ${SOURCES} ${GUIOSX_SOURCES})
 	set_target_properties(hatari PROPERTIES MACOSX_BUNDLE_INFO_PLIST
 			      ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/Info-Hatari.plist)
 	set(MACOSX_BUNDLE_ICON_FILE Hatari.icns)
+	if(CMAKE_GENERATOR MATCHES "Xcode")
+		set(BUNDLE_CONTENTS ${CMAKE_CURRENT_BINARY_DIR}/\${CONFIGURATION}/Hatari.app/Contents)
+	else()
+		set(BUNDLE_CONTENTS ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents)
+	endif()
 	# Create Hatari.app bundle
 	add_custom_target(osx_bundle_dirs
-			COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources
-			COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/MacOS
+			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources
+			COMMAND mkdir -p ${BUNDLE_CONTENTS}/MacOS
 			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
-				   ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources/${MACOSX_BUNDLE_ICON_FILE}
+				   ${BUNDLE_CONTENTS}/Resources/${MACOSX_BUNDLE_ICON_FILE}
 			# Copy Localized .nib to Bundle
-			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources/
-	)	
+			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${BUNDLE_CONTENTS}/Resources/
+			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/English.lproj/HatariHelp
+			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/English.lproj/HatariHelp/
+			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/French.lproj/HatariHelp
+			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/French.lproj/HatariHelp/
+	)
 	add_dependencies(hatari osx_bundle_dirs)
-	set_source_files_properties(${GUIOSX_RSRCS}
-			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
+	set_source_files_properties(${GUIOSX_RSRCS} PROPERTIES
+				    MACOSX_PACKAGE_LOCATION Resources)
+	set_source_files_properties(${GUIOSX_DOCS} PROPERTIES
+				    MACOSX_PACKAGE_LOCATION Resources/English.lproj/HatariHelp)
 
 # When building for Windows, add specific sources + method to compile .rc files
 elseif(WIN32)
@@ -129,6 +143,10 @@
 	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
 endif(PORTAUDIO_FOUND)
 
+if(CAPSIMAGE_FOUND)
+	target_link_libraries(hatari ${CAPSIMAGE_LIBRARY})
+endif(CAPSIMAGE_FOUND)
+
 if(WIN32)
 	# Needed for socket() on Windows
 	target_link_libraries(hatari ws2_32)

=== tools/CMakeLists.txt ===

add_subdirectory(hmsa)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(hconsole)
	add_subdirectory(debugger)
endif(PYTHONINTERP_FOUND)

install(PROGRAMS atari-hd-image.sh DESTINATION ${BINDIR} RENAME atari-hd-image)
install(PROGRAMS zip2st.sh DESTINATION ${BINDIR} RENAME zip2st)

# if(UNIX)
	add_custom_target(atari_hd_image_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/atari-hd-image.1 > ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz
		DEPENDS atari-hd-image.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz DESTINATION ${MANDIR})

	add_custom_target(zip2st_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/zip2st.1 > ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz
		DEPENDS zip2st.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== src/debug/CMakeLists.txt ===

if(READLINE_FOUND)
	include_directories(${READLINE_INCLUDE_DIR})
endif(READLINE_FOUND)

if(ENABLE_DSP_EMU)
	set(DSPDBG_C debugdsp.c)
endif(ENABLE_DSP_EMU)

add_library(Debug
	    log.c debugui.c breakcond.c debugcpu.c debugInfo.c
	    ${DSPDBG_C} evaluate.c history.c symbols.c
	    profile.c profilecpu.c profiledsp.c
	    natfeats.c console.c 68kDisass.c)

=== src/falcon/CMakeLists.txt ===

if(PORTAUDIO_FOUND)
	include_directories(${PORTAUDIO_INCLUDE_DIR})
endif(PORTAUDIO_FOUND)

if(ENABLE_DSP_EMU)
	set(DSP_SOURCES dsp_core.c dsp_cpu.c dsp_disasm.c)
endif(ENABLE_DSP_EMU)

add_library(Falcon
	crossbar.c dsp.c ${DSP_SOURCES}
	hostscreen.c microphone.c nvram.c videl.c
	)

=== src/gui-sdl/CMakeLists.txt ===

include_directories(. ../.. ../debug ../includes ${SDL_INCLUDE_DIR}) 

if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-write-strings")
endif(CMAKE_COMPILER_IS_GNUCC)

add_library(GuiSdl
	dlgAbout.c dlgAlert.c dlgDevice.c dlgFileSelect.c dlgFloppy.c
	dlgHardDisk.c dlgJoystick.c dlgKeyboard.c dlgMain.c dlgMemory.c
	dlgNewDisk.c dlgRom.c dlgScreen.c dlgSound.c dlgSystem.c
	sdlgui.c
	)

=== tools/debugger/CMakeLists.txt ===

include_directories(${SDL_INCLUDE_DIR})

add_executable(gst2ascii gst2ascii.c)

install(TARGETS gst2ascii RUNTIME DESTINATION ${BINDIR})

install(PROGRAMS hatari_profile.py DESTINATION ${BINDIR})

# if(UNIX)
	add_custom_target(gst2ascii_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/gst2ascii.1 > ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz
		DEPENDS gst2ascii.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz DESTINATION ${MANDIR})

	add_custom_target(hatari_profile_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatari_profile.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz
		DEPENDS hatari_profile.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== tools/hmsa/CMakeLists.txt ===

include_directories(${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/src/includes
		    ${CMAKE_SOURCE_DIR}/src/debug ${SDL_INCLUDE_DIR})

if(ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIR})
endif(ZLIB_FOUND)

add_executable(hmsa hmsa.c floppy.c ../../src/file.c ../../src/unzip.c)

target_link_libraries(hmsa Floppy)

if(MATH_FOUND)
	target_link_libraries(hmsa ${MATH_LIBRARY})
endif(MATH_FOUND)

if(ZLIB_FOUND)
	target_link_libraries(hmsa ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

install(TARGETS hmsa RUNTIME DESTINATION ${BINDIR})

# if(UNIX)
	add_custom_target(hmsa_manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hmsa.1 > ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz
		DEPENDS hmsa.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== debian/changelog ===
hatari (1.8.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
    Highlights:
    - Accurate timings for floppy access.
    - Support for Pasti STX floppy images.
    - Support new Native Features, allowing emulated code to affect the
      emulator (NF_EXIT, NF_DEBUGGER, NF_FASTFORWARD).
    - Release mouse when debugger is invoked.
    - "quit" debugger command bypasses exit confirmation dialog.
    - Current program's debugging symbols are loaded automatically when
      entering the debugger.
  * Repack source, removing src/tos.img. It is licensed under GPLv2, but
    source code is not included with hatari. Add appropriate
    Files-Excluded line to debian/copyright.
  * Add menu entry for the python GTK hatari UI.
  * Update years in debian/copyright.
  * Refresh debian/patches/02-fix-manpage-hyphens.patch.
  * Add debian/patches/04-fix-typo-in-manpage.patch, as identified by
    lintian.
  * Bump standards-version to 3.9.5, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Wed, 30 Jul 2014 22:07:40 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libreadline-dev,
                portaudio19-dev,
                python
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://hatari.tuxfamily.org/
 
 Package: hatari

=== debian/rules ===
#!/usr/bin/make -f

#include /usr/share/dpkg/buildflags.mk

LDFLAGS += -Wl,--as-needed
CFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake --builddirectory=build --with=python2

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake \
	  -O--builddirectory=build \
	  -- \
	  -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	  -DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
	  -DCMAKE_CXX_FLAGS:STRING="$(CFLAGS)" \
          -DCMAKE_LINK_FLAGS:STRING="$(LDFLAGS)"
	dh_auto_configure -O--buildsystem=cmake \
	  -O--builddirectory=build-winuae \
	  -- \
	  -DENABLE_WINUAE_CPU:BOOL=1 \
	  -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	  -DCMAKE_SKIP_RPATH:BOOL=1 \
	  -DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
	  -DCMAKE_CXX_FLAGS:STRING="$(CFLAGS)" \
          -DCMAKE_LINK_FLAGS:STRING="$(LDFLAGS)"

override_dh_auto_build:
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build-winuae

override_dh_install:
	dh_install --sourcedir=build

	# Install WinUAE version of hatari binary
	# Rename file
	mv build-winuae/src/hatari build-winuae/src/hatari-winuae
	dh_install --sourcedir=build-winuae src/hatari-winuae /usr/bin

	# Remove bundled EmuTOS image
	-rm debian/hatari/usr/share/hatari/tos.img

	# Install binfmt support for atari binaries
	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari

override_dh_installman:
	dh_installman
	dh_installman debian/hatari-winuae.1

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake -O--builddir=build
	dh_auto_clean -O--buildsystem=cmake -O--builddirectory=build-winuae
	find . -name *.pyc -exec rm -f {} \;

=== debian/watch ===
version=3
        opts=dversionmangle=s/\+dfsg// \
        http://download.tuxfamily.org/hatari/(\d\.\d\.\d)/hatari-(.*).tar.bz2
